## avian 0.6+20121011

=== debian/changelog ===
avian (0.6+20121011-1) unstable; urgency=low

  * Update to 20121011.
  * fix sun.misc.Unsafe.getLongVolatile for static fields on 32-bit platforms.
  * fix reads of out-of-bounds values in tokenizer.h
  * fix incorrect reporting of fixie collection status in heap.cpp
  * fix a couple of ByteBuffer regressions
  * fix a couple of OpenJDK reflection bugs, allows avian to run icedtea-netx.
  * make JVM_GetSystemPackage a bit smarter, allows avian to run javazoom jlgui.
  * fix missing armv4 blx and bkpt compile errors. Unbreak build on
    Debian armel.
  * return null from JNIEnv::GetSuperclass for interfaces per spec
  * gcc define __ARM_PCS_VFP for -mfloat-abi=hard, use it to detect armhf
  * handle zero length arrays properly in JNIEnv::NewString
  * fix abort in classpath-openjdk.cpp due to buffer overflow
  * fix OS X 10.8 and iOS 6.0 builds
  * use ldmneia on Clang < 4 and GCC, ldmiane on Clang >= 4
  * clear any weak/soft/phantom references to finalizable objects before queuing
  * fix Call[Static]<type>MethodA float argument marshalling
  * update static table class reference in updateClassTables
  * update static table mapping code in bootimage.cpp to match machine.cpp
  * rename package avian.avian_vm_resource to avian.avianvmresource

 -- Xerxes Rånby <xerxes@zafena.se>  Thu, 11 Oct 2012 10:39:39 +0200

avian (0.6+20120911-0ubuntu1) quantal; urgency=low

  * Update to 20120911.
  * add JNI_GetCreatedJavaVMs stub. (LP: #1047395)
  * Drop soname.diff and version-info.diff patches that are now upstream.

 -- Xerxes Rånby <xerxes@zafena.se>  Mon, 10 Sep 2012 12:06:29 +0200

avian (0.6+20120905-1) unstable; urgency=low

  * Initial release. Closes: #686760.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 05 Sep 2012 12:24:24 +0200

avian (0.6+20120905-0ubuntu1) quantal; urgency=low

  * Initial release. Closes: #686760.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 05 Sep 2012 12:24:24 +0200

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

d = debian/jvm-7-avian-jre

DPKG_CFLAGS  := $(shell dpkg-buildflags --get CPPFLAGS; dpkg-buildflags --get CFLAGS)
DPKG_LFLAGS := $(shell dpkg-buildflags --get LDFLAGS)

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

archdir_map  = armel=arm armhf=arm amd64=amd64 i386=i386 powerpc=ppc powerpcspe=ppc

archdir := $(strip $(patsubst $(DEB_HOST_ARCH)=%, %, \
               $(filter $(DEB_HOST_ARCH)=%, $(archdir_map))))

ifeq ($(DEB_HOST_ARCH),amd64)
  AVIAN_ARCH = x86_64
else ifneq (,$(filter $(DEB_HOST_ARCH),armel armhf))
  AVIAN_ARCH = arm
else
  AVIAN_ARCH = $(DEB_HOST_ARCH)
endif

# segfault with -flto on ARM and powerpc
ifneq (,$(filter $(DEB_HOST_ARCH),amd64 i386))
  use_lto=true
endif

JAVA_HOME = /usr/lib/jvm/java-7-openjdk-$(DEB_HOST_ARCH)

version := $(shell dpkg-parsechangelog | awk '/^Version:/ {print $$2}')
info := package $(version)

%:
	dh $@ 

override_dh_auto_configure:

override_dh_auto_build:
	make MAKEFLAGS= \
		JAVA_HOME=$(JAVA_HOME) \
		openjdk=$(JAVA_HOME) \
		build-cc=gcc-4.7 build-cxx=g++-4.7 \
		DPKG_CFLAGS="$(DPKG_CFLAGS)" \
		DPKG_LFLAGS="$(DPKG_LFLAGS)" \
		use-lto=$(use_lto) \
		info='$(info)'

override_dh_auto_test:
	make MAKEFLAGS= test \
		JAVA_HOME=$(JAVA_HOME) \
		openjdk=$(JAVA_HOME)

override_dh_auto_install:
	mkdir -p $(d)/$(JAVA_HOME)/jre/lib/$(archdir)/avian
	cp build/linux-$(AVIAN_ARCH)-openjdk/libjvm.so \
		$(d)/$(JAVA_HOME)/jre/lib/$(archdir)/avian/.
	dh_install

override_dh_auto_clean:
	rm -rf build
	dh_auto_clean

## avian 1.1.0

=== CMakeLists.txt ===
# NOTE that this CMake file doesn't current build all of avian.
# It only builds what's required for example/kaleidoscope.

cmake_minimum_required (VERSION 2.6)
project (avian)

include_directories (include src)

add_definitions (
  -DAVIAN_TARGET_FORMAT=AVIAN_FORMAT_MACHO

  -DAVIAN_TARGET_ARCH=AVIAN_ARCH_X86_64

  -DTARGET_BYTES_PER_WORD=8
  -D__STDC_LIMIT_MACROS
  -D__STDC_CONSTANT_MACROS
)

include ("cmake/Platform.cmake")

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${PLATFORM_CXX_FLAGS}")

include (CTest)

# Sadly, we can't use the 'test' target, as that's coopted by ctest
add_custom_target(check ${CMAKE_CTEST_COMMAND} -V)

add_subdirectory (src)
add_subdirectory (unittest)

=== src/CMakeLists.txt ===
add_subdirectory(codegen)
add_subdirectory(system)
add_subdirectory(heap)
add_subdirectory(util)
add_subdirectory(tools)

add_library(avian_jvm_finder finder.cpp)

=== unittest/CMakeLists.txt ===

include_directories (${CMAKE_CURRENT_SOURCE_DIR})

add_executable (avian_unittest
  test-harness.cpp

  codegen/assembler-test.cpp
  codegen/registers-test.cpp

  util/arg-parser-test.cpp
)

target_link_libraries (avian_unittest
  avian_codegen
  avian_codegen_x86
  avian_system
  avian_heap
  avian_util
  ${PLATFORM_LIBS}
)

add_test(NAME avian_unittest COMMAND avian_unittest)
add_dependencies(check avian_unittest)

=== src/codegen/CMakeLists.txt ===
add_library (avian_codegen
  compiler.cpp
  registers.cpp
  runtime.cpp
  targets.cpp

  compiler/context.cpp
  compiler/event.cpp
  compiler/frame.cpp
  compiler/ir.cpp
  compiler/promise.cpp
  compiler/read.cpp
  compiler/regalloc.cpp
  compiler/resource.cpp
  compiler/site.cpp
  compiler/value.cpp
)

add_subdirectory(target)

=== src/heap/CMakeLists.txt ===

add_library(avian_heap heap.cpp)

=== src/system/CMakeLists.txt ===

if (MSVC)
  #todo: support mingw compiler
  add_library(avian_system windows.cpp windows/crash.cpp)
else()
  add_library(avian_system posix.cpp posix/crash.cpp)
endif()

=== src/tools/CMakeLists.txt ===
add_subdirectory(binary-to-object)
add_subdirectory(object-writer)
add_subdirectory(type-generator)

=== src/util/CMakeLists.txt ===
add_library(avian_util arg-parser.cpp fixed-allocator.cpp)

=== src/codegen/target/CMakeLists.txt ===
add_subdirectory(arm)
add_subdirectory(x86)

=== src/tools/binary-to-object/CMakeLists.txt ===
add_executable(binary_to_object main.cpp)

target_link_libraries(binary_to_object object_writer)

=== src/tools/object-writer/CMakeLists.txt ===
add_library(object_writer
  elf.cpp
  mach-o.cpp
  pe.cpp
  tools.cpp
)

=== src/tools/type-generator/CMakeLists.txt ===
add_executable(type_generator main.cpp)

target_link_libraries(type_generator
  avian_jvm_finder
  avian_system
  avian_util
  ${ZLIB_LIBRARIES}
  ${PLATFORM_LIBS}
)

## avian 0.6+20130401

=== debian/changelog ===
avian (0.6+20130401-0ubuntu1) raring; urgency=low

  * Update to 20130401.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 01 Apr 2013 12:19:33 +0200

=== debian/control ===
Source: avian
Section: java
Priority: extra
Maintainer: OpenJDK Team <openjdk@lists.launchpad.net>
Uploaders: Matthias Klose <doko@ubuntu.com>, Xerxes Rånby <xerxes@zafena.se>
Build-Depends: debhelper (>= 8.0.0), openjdk-7-jdk, zlib1g-dev, g++-4.7
Standards-Version: 3.9.3
Homepage: http://oss.readytalk.com/avian/

Package: jvm-7-avian-jre
Architecture: amd64 armel armhf i386 powerpc
Depends: ${shlibs:Depends}, ${misc:Depends}, openjdk-7-jre-headless
Description: lightweight virtual machine using the OpenJDK class library
 Avian is a lightweight virtual machine and class library designed
 to provide a useful subset of Java's features, suitable for building
 self-contained applications.
 .
 The VM is implemented from scratch and designed to be both fast and small.
 .
  - Just-In-Time (JIT) compilation for fast method execution.
  - Generational, copying garbage collection ensures short pause times and good
    spatial locality.
  - Thread-local heaps provide O(1) memory allocation with no synchronization
    overhead.
  - Null pointer dereferences are handled via OS signals to avoid unnecessary
    branches.

=== debian/rules ===
--- 
+++ 
@@ -50,7 +50,7 @@
 		info='$(info)'
 
 override_dh_auto_test:
-	make MAKEFLAGS= test \
+	-make MAKEFLAGS= test \
 		JAVA_HOME=$(JAVA_HOME) \
 		openjdk=$(JAVA_HOME)

## avian 0.7+20140401

=== debian/changelog ===
avian (0.7+20140401-1) unstable; urgency=low

  * Update to 20140401.

 -- Xerxes Rånby <xerxes@zafena.se>  Fri, 04 Apr 2013 15:44:39 +0200
 

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: extra
 Maintainer: OpenJDK Team <openjdk@lists.launchpad.net>
 Uploaders: Matthias Klose <doko@ubuntu.com>, Xerxes Rånby <xerxes@zafena.se>
-Build-Depends: debhelper (>= 8.0.0), openjdk-7-jdk, zlib1g-dev, g++-4.7
+Build-Depends: debhelper (>= 8.0.0), openjdk-7-jdk, zlib1g-dev, g++
 Standards-Version: 3.9.3
 Homepage: http://oss.readytalk.com/avian/

=== debian/rules ===
--- 
+++ 
@@ -43,7 +43,7 @@
 	make MAKEFLAGS= \
 		JAVA_HOME=$(JAVA_HOME) \
 		openjdk=$(JAVA_HOME) \
-		build-cc=gcc-4.7 build-cxx=g++-4.7 \
+		build-cc=gcc build-cxx=g++ \
 		DPKG_CFLAGS="$(DPKG_CFLAGS)" \
 		DPKG_LFLAGS="$(DPKG_LFLAGS)" \
 		use-lto=$(use_lto) \

=== debian/watch ===
version=3
http://oss.readytalk.com/avian/status.html avian-(.*)\.tar\.bz2

## avian 1.1.0

=== debian/changelog ===
avian (1.1.0-4) unstable; urgency=medium

  * Build-depend on locales-all | language-pack-en-base.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 14 Nov 2014 15:09:13 +0100

avian (1.1.0-3) unstable; urgency=low

  * remove no-lto workaround needed for older distro releases.
    closes: #768682
  * Use LANG=C.UTF-8 to correctly compile
    tests using UTF-8 inner class names.

 -- Xerxes Rånby <xerxes@zafena.se>  Fri, 14 Nov 2014 12:41:14 +0100

avian (1.1.0-2) unstable; urgency=low

  * debian/patches/openjdk-JVM_FindClassFromCaller.diff
    Add compatibility with IcedTea 2.5.3 update.
  * debian/control: Remove powerpc, ppc is not a supported architecture.

 -- Xerxes Rånby <xerxes@zafena.se>  Thu, 13 Nov 2014 15:15:56 +0100

avian (1.1.0-1) unstable; urgency=low

  [ Xerxes Rånby ]
  * Update to 1.1.0.
  * Add compatibility with recent OpenJDK releases, closes: #759834
  * non-reproducible gold linker internal error on amd64, closes: #753182

  [ Matthias Klose ]
  * Build using the default GCC.
  * Remove debian template files.
  * Build with -g instead of -g3 to avoid an LTO ICE.
  * Still build with -marm on armhf, apparently the package is not ready
    for thumb mode.
  * Still build without LTO on ARM32.

 -- Xerxes Rånby <xerxes@zafena.se>  Mon, 20 Oct 2014 16:21:56 +0200

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,15 @@
 Priority: extra
 Maintainer: OpenJDK Team <openjdk@lists.launchpad.net>
 Uploaders: Matthias Klose <doko@ubuntu.com>, Xerxes Rånby <xerxes@zafena.se>
-Build-Depends: debhelper (>= 8.0.0), openjdk-7-jdk, zlib1g-dev, g++
-Standards-Version: 3.9.3
+Build-Depends: debhelper (>= 8.0.0),
+  openjdk-7-jdk, zlib1g-dev,
+  locales-all | language-pack-en-base
+Standards-Version: 3.9.6
 Homepage: http://oss.readytalk.com/avian/
 
 Package: jvm-7-avian-jre
-Architecture: amd64 armel armhf i386 powerpc
-Depends: ${shlibs:Depends}, ${misc:Depends}, openjdk-7-jre-headless
+Architecture: amd64 armel armhf i386
+Depends: ${shlibs:Depends}, ${misc:Depends}, openjdk-7-jre-headless (>= 7u71-2.5.3-1~)
 Description: lightweight virtual machine using the OpenJDK class library
  Avian is a lightweight virtual machine and class library designed
  to provide a useful subset of Java's features, suitable for building

=== debian/rules ===
--- 
+++ 
@@ -6,6 +6,8 @@
 
 d = debian/jvm-7-avian-jre
 
+export DEB_CFLAGS_MAINT_STRIP = -O2
+export DEB_CFLAGS_MAINT_APPEND = -O3
 DPKG_CFLAGS  := $(shell dpkg-buildflags --get CPPFLAGS; dpkg-buildflags --get CFLAGS)
 DPKG_LFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
 
@@ -41,6 +43,7 @@
 
 override_dh_auto_build:
 	make MAKEFLAGS= \
+		DEB_HOST_ARCH=$(DEB_HOST_ARCH) \
 		JAVA_HOME=$(JAVA_HOME) \
 		openjdk=$(JAVA_HOME) \
 		build-cc=gcc build-cxx=g++ \
@@ -50,9 +53,16 @@
 		info='$(info)'
 
 override_dh_auto_test:
-	-make MAKEFLAGS= test \
+	-LANG=C.UTF-8 \
+	    make MAKEFLAGS= test \
+		DEB_HOST_ARCH=$(DEB_HOST_ARCH) \
 		JAVA_HOME=$(JAVA_HOME) \
-		openjdk=$(JAVA_HOME)
+		openjdk=$(JAVA_HOME) \
+		build-cc=gcc build-cxx=g++ \
+		DPKG_CFLAGS="$(DPKG_CFLAGS)" \
+		DPKG_LFLAGS="$(DPKG_LFLAGS)" \
+		use-lto=$(use_lto) \
+		info='$(info)'
 
 override_dh_auto_install:
 	mkdir -p $(d)/$(JAVA_HOME)/jre/lib/$(archdir)/avian
